clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Computer Exercises - Exerccio 2 - Captulo 10
%Pattern Classification - Duda, Hart & Stork
%Adrielle C. Santana
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Entrada de dados em 3-D 20X3

D = [-7.82 -4.58 -3.97;
     -6.68  3.16  2.71;
     4.36 -2.19  2.09;
     6.72  0.88  2.80;
     -8.64  3.06  3.50;
     -6.87  0.57 -5.45;
     4.47 -2.62  5.76;
     6.73 -2.01  4.18;
     -7.71  2.34 -6.33;
     -6.91 -0.49 -5.68;
     6.18  2.81  5.82;
     6.72 -0.93 -4.04;
    -6.25 -0.26  0.56;
    -6.94 -1.22  1.13;
     8.09  0.20  2.25;
     6.81  0.17 -4.15;
    -5.19  4.24  4.04;
    -6.38 -1.74  1.43;
     4.08  1.30  5.33;
     6.27  0.93 -2.78];

figure(1)
title('Dados de Entrada')
scatter3(D(:,1),D(:,2),D(:,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0 0])
view(7,26)
xlabel('x1')
ylabel('x2')
zlabel('x3')
[N,l]=size(D);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%a) c=2 grupos/classes e centroides iniciais m1=(1,1,1) e m2=(-1,1,-1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c=2;
m=[1 1 1; -1 1 -1];
grupo1=[];
grupo2=[];
[Classe1, iter1, dif1, m_resp]=Func_k_medias(D,c,m);
t1=0; %contador de posies para o grupo 1
t2=0; %contador de posies para o grupo 2
for i=1:N
if (Classe1(1,i)==1)
    t1=t1+1;
    grupo1(t1,:)=D(i,:);
else
    t2=t2+1;
    grupo2(t2,:)=D(i,:);
end
end
figure (2)
title('Resposta do exerccio 2 item "a"')
if(t1>0)
scatter3(grupo1(1:t1,1),grupo1(1:t1,2),grupo1(1:t1,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0 0])
end
hold on
scatter3(m_resp(1:2,1),m_resp(1:2,2),m_resp(1:2,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0.9 0])
hold on
scatter3(m(1:2,1),m(1:2,2),m(1:2,3),'k','filled')
if(t2>0)
hold on
scatter3(grupo2(1:t2,1),grupo2(1:t2,2),grupo2(1:t2,3),'MarkerEdgeColor','k','MarkerFaceColor',[0 0.75 0.75])
end
hold off
view(7,26)
xlabel(['x1     Iteraes: ',num2str(iter1)])
ylabel('x2')
zlabel('x3')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%b) c=2 grupos/classes e centroides iniciais m1=(0,0,0) e m2=(1,1,-1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c=2;
m=[0 0 0; 1 1 -1];
grupo1=[];
grupo2=[];
[Classe2, iter2, dif2,m_resp]=Func_k_medias(D,c,m);
t1=0; %contador de posies para o grupo 1
t2=0; %contador de posies para o grupo 2
for i=1:N
if (Classe2(1,i)==1)
    t1=t1+1;
    grupo1(t1,:)=D(i,:);
else
    t2=t2+1;
    grupo2(t2,:)=D(i,:);
end
end
figure (3)
title('Resposta do exerccio 2 item "a"')
if(t1>0)
scatter3(grupo1(1:t1,1),grupo1(1:t1,2),grupo1(1:t1,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0 0])
end
hold on
scatter3(m_resp(1:2,1),m_resp(1:2,2),m_resp(1:2,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0.9 0])
hold on
scatter3(m(1:2,1),m(1:2,2),m(1:2,3),'k','filled')
if(t2>0)
hold on
scatter3(grupo2(1:t2,1),grupo2(1:t2,2),grupo2(1:t2,3),'MarkerEdgeColor','k','MarkerFaceColor',[0 0.75 0.75])
end
hold off
view(7,26)
xlabel(['x1     Iteraes: ',num2str(iter2)])
ylabel('x2')
zlabel('x3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%c) c=3 grupos/classes e centroides iniciais m1=(0,0,0), m2=(1,1,1) e m3=(-1,0,2)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c=3;
m=[0 0 0; 1 1 1;-1 0 2];
grupo1=[];
grupo2=[];
grupo3=[];
[Classe3, iter3, dif3,m_resp]=Func_k_medias(D,c,m);
t1=0; %contador de posies para o grupo 1
t2=0; %contador de posies para o grupo 2
t3=0; %contador de posies para o grupo 3
for i=1:N
if (Classe3(1,i)==1)
    t1=t1+1;
    grupo1(t1,:)=D(i,:);
elseif(Classe3(2,i)==1)
    t2=t2+1;
    grupo2(t2,:)=D(i,:);
else
    t3=t3+1;
    grupo3(t3,:)=D(i,:);
end
end
figure (4)
title('Resposta do exerccio 2 item "a"')
if(t1>0)
scatter3(grupo1(1:t1,1),grupo1(1:t1,2),grupo1(1:t1,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0 0])
end
hold on
scatter3(m_resp(1:3,1),m_resp(1:3,2),m_resp(1:3,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0.9 0])
hold on
scatter3(m(1:3,1),m(1:3,2),m(1:3,3),'k','filled')
if(t2>0)
hold on
scatter3(grupo2(1:t2,1),grupo2(1:t2,2),grupo2(1:t2,3),'MarkerEdgeColor','k','MarkerFaceColor',[0 0.75 0.75])
end
if(t3>0)
hold on
scatter3(grupo3(1:t3,1),grupo3(1:t3,2),grupo3(1:t3,3),'MarkerEdgeColor','k','MarkerFaceColor',[0.75 0.5 1])
end
hold off
view(7,26)
xlabel(['x1     Iteraes: ',num2str(iter3)])
ylabel('x2')
zlabel('x3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%c) c=3 grupos/classes e centroides iniciais m1=(-0.1,0,0.1), m2=(0,-0.1,0.1) e m3=(-0.1,-0.1,0.1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c=3;
m=[-0.1 0 0.1; 0 -0.1 0.1;-0.1 -0.1 0.1];
grupo1=[];
grupo2=[];
grupo3=[];
[Classe4, iter4, dif4,m_resp]=Func_k_medias(D,c,m);
t1=0; %contador de posies para o grupo 1
t2=0; %contador de posies para o grupo 2
t3=0; %contador de posies para o grupo 3
for i=1:N
if (Classe4(1,i)==1)
    t1=t1+1;
    grupo1(t1,:)=D(i,:);
elseif(Classe4(2,i)==1)
    t2=t2+1;
    grupo2(t2,:)=D(i,:);
else
    t3=t3+1;
    grupo3(t3,:)=D(i,:);
end
end
figure (5)
title('Resposta do exerccio 2 item "a"')
if(t1>0)
scatter3(grupo1(1:t1,1),grupo1(1:t1,2),grupo1(1:t1,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0 0])
end
hold on
scatter3(m_resp(1:3,1),m_resp(1:3,2),m_resp(1:3,3),'MarkerEdgeColor','k','MarkerFaceColor',[1 0.9 0])
hold on
scatter3(m(1:3,1),m(1:3,2),m(1:3,3),'k','filled')
if(t2>0)
hold on
scatter3(grupo2(1:t2,1),grupo2(1:t2,2),grupo2(1:t2,3),'MarkerEdgeColor','k','MarkerFaceColor',[0 0.75 0.75])
end
if(t3>0)
hold on
scatter3(grupo3(1:t3,1),grupo3(1:t3,2),grupo3(1:t3,3),'MarkerEdgeColor','k','MarkerFaceColor',[0.75 0.5 1])
end
hold off
view(7,26)
xlabel(['x1     Iteraes: ',num2str(iter4)])
ylabel('x2')
zlabel('x3')